image: golang:latest

.go-cache:
  variables:
    GOPATH: $CI_PROJECT_DIR/.go
  cache:
    paths:
      - .go/pkg/mod
    key:
      files:
        - go.mod

stages:
  - deps
  - lint
  - test

deps:
  stage: deps
  extends: .go-cache
  script:
    - go get -t

lint:
  image: golangci/golangci-lint:latest
  stage: lint
  extends: .go-cache
  cache:
    policy: pull
  script:
    - golangci-lint run -v

test:
  stage: test
  extends: .go-cache
  cache:
    policy: pull
  script:
    - go fmt ./...
    - go vet ./...
    - go test -race ./...
